/**
 * DO NOT EDIT
 *
 * This file was automatically generated by
 *   https://github.com/Polymer/tools/tree/master/packages/gen-typescript-declarations
 *
 * To modify these typings, edit the source file(s):
 *   property-document-mixin.js
 */


// tslint:disable:variable-name Describing an API that's defined elsewhere.
// tslint:disable:no-any describes the API as best we are able today

import {dedupingMixin} from '@polymer/polymer/lib/utils/mixin.js';

export {PropertyDocumentMixin};

declare namespace ArcBehaviors {


  /**
   * A mixin that contains common function for `property-*-document` elements.
   */
  function PropertyDocumentMixin<T extends new (...args: any[]) => {}>(base: T): T & PropertyDocumentMixinConstructor;

  interface PropertyDocumentMixinConstructor {
    new(...args: any[]): PropertyDocumentMixin;
  }

  interface PropertyDocumentMixin {

    /**
     * Type's current media type.
     * This is used to select/generate examples according to current body
     * media type. When not set it only renders examples that were defined
     * in API specfile in a form as they were written.
     */
    mediaType: string|null|undefined;

    /**
     * Generated AMF json/ld model form the API spec.
     * The element assumes the object of the first array item to be a
     * type of `"http://raml.org/vocabularies/document#Document`
     * on AMF vocabulary.
     *
     * It is only usefult for the element to resolve references.
     */
    amf: object|any[]|null;

    /**
     * A property shape definition of AMF.
     */
    shape: object|null;

    /**
     * Computes value of shape's http://raml.org/vocabularies/shapes#range
     */
    range: object|null;

    /**
     * When set it removes actions bar from the examples render.
     */
    noExamplesActions: boolean|null|undefined;
    _hasMediaType: boolean|null|undefined;
    _setObservableProperty(prop: any, value: any): any;

    /**
     * Computes type from a `http://raml.org/vocabularies/shapes#range` object
     *
     * @param range AMF property range object
     * @returns Data type of the property.
     */
    _computeRangeDataType(range: object|null): String|null;

    /**
     * Computes value for `range` property.
     *
     * @param shape Current shape object.
     * @returns Range object
     */
    _computeRange(shape: object|null): object|null;

    /**
     * Computes properties to render Array items documentation.
     *
     * @param range Range object of current shape.
     * @returns List of Array items.
     */
    _computeArrayProperties(range: object|null): Array<object|null>|null|undefined;

    /**
     * Computes value for `isUnion` property.
     * Union type is identified as a `http://raml.org/vocabularies/shapes#UnionShape`
     * type.
     *
     * @param range Range object of current shape.
     */
    _computeIsUnion(range: object|null): Boolean|null;

    /**
     * Computes value for `isObject` property.
     * Object type is identified as a `http://raml.org/vocabularies/shapes#NodeShape`
     * type.
     *
     * @param range Range object of current shape.
     */
    _computeIsObject(range: object|null): Boolean|null;

    /**
     * Computes value for `isArray` property.
     * Array type is identified as a `http://raml.org/vocabularies/shapes#ArrayShape`
     * type.
     *
     * @param range Range object of current shape.
     */
    _computeIsArray(range: object|null): Boolean|null;

    /**
     * Computes list of union type labels to render.
     */
    _computeUnionTypes(isUnion: Boolean|null, range: object|null): Array<object|null>|null;

    /**
     * Computes union type label when the union is in Array.
     *
     * @param items Array's items property or a single property
     * @returns Label for the union type.
     */
    _computeArrayUnionLabel(items: any[]|object|null): String|null|undefined;

    /**
     * Computes name label for the shape.
     *
     * @param range Range object of current shape.
     * @param shape The shape of the property.
     * @returns Display name of the property
     */
    _computeDisplayName(range: object|null, shape: object|null): String|null;
    _computeHasMediaType(mediaType: any): any;
  }
}

export {PropertyDocumentMixinConstructor};
